// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
import { makeTextAnalyticsSuccessResult, makeTextAnalyticsErrorResult } from "./textAnalyticsResult";
/**
 * @internal
 */
export function makeExtractKeyPhrasesResult(result) {
    const { id, warnings, statistics, keyPhrases } = result;
    return Object.assign(Object.assign({}, makeTextAnalyticsSuccessResult(id, warnings, statistics)), { keyPhrases });
}
/**
 * @internal
 */
export function makeExtractKeyPhrasesErrorResult(id, error) {
    return makeTextAnalyticsErrorResult(id, error);
}
//# sourceMappingURL=extractKeyPhrasesResult.js.map