// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
import { makeTextAnalyticsSuccessResult, makeTextAnalyticsErrorResult } from "./textAnalyticsResult";
/**
 * @internal
 */
export function makeRecognizeLinkedEntitiesResult(result) {
    const { statistics, id, warnings, entities } = result;
    return Object.assign(Object.assign({}, makeTextAnalyticsSuccessResult(id, warnings, statistics)), { entities });
}
/**
 * @internal
 */
export function makeRecognizeLinkedEntitiesErrorResult(id, error) {
    return makeTextAnalyticsErrorResult(id, error);
}
//# sourceMappingURL=recognizeLinkedEntitiesResult.js.map